//------------------------------------------------------------------------------
//title
//	[^vO
//ver
//	3.0
//designer
//	igeta kenichiro
//------------------------------------------------------------------------------

#include <machine.h>
#include <_h_c_lib.h>
#include "iodefine.h"

#define MPU_CLK			20000000UL					//}CRg[Hz]
#define MPU_TIME		(1000000000L/MPU_CLK)		//}CR쎞[ns]
#define TIME_BASE		1000000L					//[ns]
#define ENCODER_PULSE	1000						//GR[_pX
#define CONVERT_BASE	(MPU_CLK/ENCODER_PULSE*60)	//x=CONVERT_BASE/pX
#define LOG_SIZE		160							//f[^
#define LOG_LOOP		5							//f[^擾[ms]
#define SPEED_LOOP		1							//x[ms]
#define SLOW_UP_LOOP	1							//X[Abv_E[ms]
#define PGAIN			4000						//QC
#define IGAIN			25							//ϕQC
#define DA_WIDTH		200000L						//DAϊo͗pPWM̃pX[ns]

#define SW_STOP			IO.PDRB.BIT.B2
#define SW_MODE			IO.PDRB.BIT.B3
#define SW_SLOWUP		IO.PDRB.BIT.B4
#define SW_PGAIN		IO.PDRB.BIT.B5
#define SW_DATAUP		IO.PDRB.BIT.B6
#define SW_DIR			IO.PDRB.BIT.B7

#define DIR_DETECT		1							//]oƂP

//------------------------------------------------------------------------------

void SlowUpDown(void);
void MotorOut(long out, int dir);
void SpeedLoop(void);
void initialize(void);
void Sleep(unsigned long time);
void IntToStr(int data, char *str);
void TransmitData(void);
void puts(char *str);
void main(void);

//------------------------------------------------------------------------------

volatile unsigned long gSystemTime;

volatile unsigned int gWidthA;		//pX(A)
volatile int gSetSpeed;				//ݒ葬x
volatile int gSet2Speed;			//xw
volatile int gProportionalGain;		//QC
volatile int gIntegralGain;			//ϕQC
volatile int gSlowUpRatio;			//X[Abvl
volatile int gDAOut[2];				//AiOo̓obt@
volatile int gDirection;			//]

int gSpeedLog[LOG_SIZE];			//葬xobt@
int gSetSpeedLog[LOG_SIZE];			//ݒ葬xobt@
int gLogCount = LOG_SIZE;

//------------------------------------------------------------------------------
//	^C}[v
//------------------------------------------------------------------------------

__interrupt(vect=21)
void INT_TimerW(void)
{
	static int oldCapTime;
	static int flag;
	static int DAWidth[2];
	static int time;

	//pX
	if(TW.TSRW.BIT.IMFA){					//pXoH
		#if DIR_DETECT == 1
			gDirection = IO.PDR8.BIT.B2;	//]o
			IO.PDR5.BIT.B3 = gDirection;	//LED1(CCW=ON)
		#endif
		IO.PDR5.BIT.B2 = 0;					//LED2on
		TW.TSRW.BIT.IMFA = 0;
		if(flag == 0){
			gWidthA = TW.GRA - oldCapTime;	//pXvZ
		}
		oldCapTime = TW.GRA;
		TW.GRB = TW.GRA+0x8000;				//pXI[o[t[ݒ
		flag = 0;

	}
	//pX\͈͂𒴂Ăꍇ̏
	if(TW.TSRW.BIT.IMFB){					//pXI[o[t[H
		IO.PDR5.BIT.B2 = 1;					//LED2off
		TW.TSRW.BIT.IMFB = 0;
		TW.GRB = TW.GRB+0x8000;
		gWidthA = 0xffff;					//pXőɐݒ
		flag = 1;							//pXI[o[t[tOZbg

	}
	//AiOoCH1
	if(TW.TSRW.BIT.IMFC){
		TW.TSRW.BIT.IMFC = 0;
		if(TW.TIOR1.BIT.IOC == 1){
			TW.TIOR1.BIT.IOC = 2;
			TW.GRC = TW.GRC+gDAOut[0];
			DAWidth[0]=DA_WIDTH/MPU_TIME-gDAOut[0];
		}else{
			TW.GRC = TW.GRC+DAWidth[0];
			TW.TIOR1.BIT.IOC = 1;
		}
	}
	//AiOoCH2
	//ݏ
	if(TW.TSRW.BIT.IMFD){
		TW.TSRW.BIT.IMFD = 0;
		if(TW.TIOR1.BIT.IOD == 1){
			TW.TIOR1.BIT.IOD = 2;
			TW.GRD = TW.GRD+gDAOut[1];
			DAWidth[1]=DA_WIDTH/MPU_TIME-gDAOut[1];
		}else{
			TW.GRD = TW.GRD+DAWidth[1];
			TW.TIOR1.BIT.IOD = 1;

			time++;
			if(time >= TIME_BASE/DA_WIDTH){
				set_imask_ccr(0);					//d݋
				time=0;
				gSystemTime += TIME_BASE/1000000;
				if(gSystemTime%SPEED_LOOP==0){		//xH
					SpeedLoop();
				}
				if(gSystemTime%SLOW_UP_LOOP==0){	//X[Abv_EH
					SlowUpDown();
				}
			}
		}
	}
}

//------------------------------------------------------------------------------
//	[^hCoo
//------------------------------------------------------------------------------

void MotorOut(long out, int dir)
{
	TV.TCORB = out >> 12;					//ovlݒ

	if(dir >= 0){							//]H
		IO.PDR7.BIT.B4 = 1;
		IO.PDR7.BIT.B5 = 0;

	}else{									//]H
		IO.PDR7.BIT.B4 = 0;
		IO.PDR7.BIT.B5 = 1;
	}
}

//------------------------------------------------------------------------------
//	X[Abv_E
//------------------------------------------------------------------------------

void SlowUpDown(void)
{
	if(gSlowUpRatio != 0){				//X[to^cnvl[hH
		if(gSet2Speed < gSetSpeed){
			gSet2Speed+=gSlowUpRatio;
			if(gSet2Speed > gSetSpeed){
				gSet2Speed = gSetSpeed;
			}

		}else if(gSet2Speed > gSetSpeed){
			gSet2Speed-=gSlowUpRatio;
			if(gSet2Speed < gSetSpeed){
				gSet2Speed = gSetSpeed;
			}
		}
	}else{
		gSet2Speed = gSetSpeed;
	}

	if(gSet2Speed != gSetSpeed){
		IO.PDR5.BIT.B1 = 0;			//LED3on
	}else{
		IO.PDR5.BIT.B1 = 1;			//LED3off
	}
}

//------------------------------------------------------------------------------
//	x
//------------------------------------------------------------------------------

void SpeedLoop(void)
{
	static int count;
	static int speed;
	int setSpeed;
	int proportionalGain;
	int integralGain = 10;
	int difference;
	long proportional;
	static long integral;
	long out;

	setSpeed = gSet2Speed;

	proportionalGain = gProportionalGain;
	integralGain = gIntegralGain;

	//pXx(xtB[hobNM)ϊ
	if(gWidthA < 0x7fff){
		speed = CONVERT_BASE/gWidthA;	//pXȂƂxvZ

	}else{
		speed = 0;						//pXs\ȂƂx0
	}

	gDAOut[0] = speed+DA_WIDTH/MPU_TIME/5;			//x̃AiOo
	if(setSpeed > 0){
		gDAOut[1] = setSpeed+DA_WIDTH/MPU_TIME/5;	//ݒ葬x̃AiOo
	}else{
		gDAOut[1] = -setSpeed+DA_WIDTH/MPU_TIME/5;	//ݒ葬x̃AiOo
	}

	//΍vZ
	//΍=xw-xtB[hobNM
	if(setSpeed >= 0){
		difference = setSpeed-speed;	//]̂Ƃ
	}else{
		difference = -setSpeed-speed;	//t]̂Ƃ
	}

	//QCZ
	proportional = difference * proportionalGain;
	if(proportional > 0xfffff){		//̒llȏH
		proportional = 0xfffff;
	}else if(proportional < -0xfffff){	//̒llȉH
		proportional = 0;
	}

	//ϕQCZ
	integral = integral + difference * integralGain;
	if(integral > 0xfffff){		//̒llȏH
		integral = 0xfffff;
	}else if(integral < 0){			//̒llȉH
		integral = 0;
	}

	out = proportional+integral;
	if(out > 0xfffff){			//̒llȏH
		out = 0xfffff;
	}else if(out < 0){			//̒llȉH
		out = 0;
	}

	//[^[^hCoo
	MotorOut(out, setSpeed);

	//xf[^ۑ(Kv)
	if(gLogCount < LOG_SIZE){
		if(count%(LOG_LOOP/SPEED_LOOP)==0){
			if(gDirection == 1){
				gSpeedLog[gLogCount] = speed;
			}else{
				gSpeedLog[gLogCount] = -speed;
			}
			gSetSpeedLog[gLogCount] = setSpeed;
			gLogCount++;
		}
		count++;
	}

}

//------------------------------------------------------------------------------
//	
//------------------------------------------------------------------------------

void initialize(void)
{
	IO.PDR1.BYTE = 0xf8;
	IO.PCR1      = 0xef;

	IO.PDR2.BYTE = 0xff;
	IO.PCR2      = 0xfd;

	IO.PDR5.BYTE = 0xff;
	IO.PCR5      = 0xff;

	IO.PDR7.BYTE = 0x8f;
	IO.PCR7      = 0xff;

	IO.PDR8.BYTE = 0xff;
	IO.PCR8      = 0xf9;

	//`^cݒ
	AD.ADCSR.BYTE = 0x11;
	AD.ADCSR.BIT.ADST = 1;

	//^C}[uݒ
	//PWMg=MPU_CLK/4/256
	TV.TCRV0.BYTE = 0x09;
	TV.TCRV1.BYTE = 0x00;
	TV.TCSRV.BYTE = 0x06;
	TV.TCORA      = 255;
	TV.TCORB      = 0;

	//^C}[vݒ
	TW.TMRW.BYTE  = 0x80;
	TW.TCRW.BYTE  = 0x0c;
	TW.TIERW.BYTE = 0x0f;
	TW.TIOR0.BYTE = 0x04;
	TW.TIOR1.BYTE = 0x11;
	TW.GRB = 0x8000;
	TW.GRC = DA_WIDTH/MPU_TIME;
	TW.GRD = DA_WIDTH/MPU_TIME;

	set_imask_ccr(0);				//݋

	//VA|[gݒ(Kv)
	SCI3.SCR3.BYTE = 0x00;
	SCI3.SMR.BYTE = 0x00;
	SCI3.BRR = 15;
	IO.PMR1.BIT.TXD = 1;
	Sleep(10);
	SCI3.SCR3.BIT.TE = 1;
	SCI3.SCR3.BIT.RE = 1;
	SCI3.SCR3.BIT.RIE = 1;	//M݋
}

//------------------------------------------------------------------------------
//	ԑ҂[ms]
//------------------------------------------------------------------------------

void Sleep(unsigned long time)
{
	unsigned long oldTime = gSystemTime;

	while(gSystemTime-oldTime <= time){
		sleep();	//邱Ƃ̂Ń}CR~
	}
}

//------------------------------------------------------------------------------
//	𕶎ɕϊ
//------------------------------------------------------------------------------

void IntToStr(int data, char *str)
{
	if(data < 0){
		str[0] = '-';
		data = -data;
	}else{
		str[0] = ' ';
	}
	str[1] = data/1000+'0';
	data = data%1000;
	str[2] = data/100+'0';
	data = data%100;
	str[3] = data/10+'0';
	data = data%10;
	str[4] = data+'0';
	str[5] = 0;
}

//------------------------------------------------------------------------------
//	f[^M
//------------------------------------------------------------------------------

void TransmitData(void)
{
	int count;
	char str[6];

	while(gLogCount < LOG_SIZE){
		sleep();
	}

	for(count=0;count < LOG_SIZE;count++){
		IntToStr(gSpeedLog[count], str);
		puts(str);
		puts(",");
		IntToStr(gSetSpeedLog[count], str);
		puts(str);
		puts("\r\n");
	}
}

//------------------------------------------------------------------------------
//	o
//------------------------------------------------------------------------------

void puts(char *str)
{
	while(*str != 0){
		while(SCI3.SSR.BIT.TDRE==0){
			sleep();
		}
		SCI3.TDR = *str++;
	}
}

//------------------------------------------------------------------------------
//	C
//------------------------------------------------------------------------------

void main(void)
{
	int sw;
	int mode=0;

	initialize();

	while(1){
		if(SW_MODE == 1){
			while(IO.PDR1.BIT.B4 == 1){	//SW܂ő҂
				if(SW_MODE == 0){
					break;
				}
				Sleep(10);
			}
			IO.PDR5.BIT.B0 = 0;			//LED4on
			IO.PDR8.BIT.B0 = 1;
			while(IO.PDR1.BIT.B4 == 0){	//SW܂ő҂
				Sleep(10);
			}
			IO.PDR5.BIT.B0 = 1;			//LED4off
			gLogCount = 0;				//Kv
			Sleep(10);
			mode = 1;
			IO.PDR8.BIT.B0 = 0;
		}

		if(SW_SLOWUP == 1){				//X[to^cnvl[hH
			gSlowUpRatio = AD.ADDRB/6553+1;
		}else{
			gSlowUpRatio = 0;
		}
		if(SW_STOP == 0){
			gSetSpeed = 0;

		}else if(SW_DIR == 0){
			gSetSpeed = AD.ADDRA/32;

		}else{
			gSetSpeed = -(AD.ADDRA/32);
		}

		if(SW_PGAIN == 0){
			gProportionalGain = PGAIN;	//QCW
		}else{
			gProportionalGain = PGAIN*2;//QCQ{
		}

		gIntegralGain = IGAIN*2;		//ϕQCWQ{

		Sleep(1);

		if(SW_DATAUP == 1 && mode == 1){
			mode=0;
			TransmitData();
		}
	}
}

//------------------------------------------------------------------------------
